//http://forum.lazarus.freepascal.org/index.php?topic=11083.0
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, LCLType,
  LCLIntf, ExtCtrls, StdCtrls, LMessages;

type

  { TForm1 }

  TForm1 = class(TForm)
    PanFormTitle: TPanel;
    LabMaxRestore: TLabel;
    LabClose: TLabel;
    LabMin: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormMinMaxCloseBtnClicks(Sender: TObject);
    procedure FormMoveMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMoveMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure FormMoveMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LabelMinMaxCloseMouseEnter(Sender: TObject);
    procedure LabelMinMaxCloseMouseLeave(Sender: TObject);
  private
    md :boolean;
    x0, y0 :integer;
  protected
    {$IFDEF LCLwin32}procedure WndProc(var Message: TLMessage); override;{$ENDIF}
  public
    { public declarations }

  end;

var
  Form1: TForm1;

implementation
{$ifdef Windows}uses Windows;{$endif}
{$R *.lfm}


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  PanFormTitle.Caption:=Caption;

  {$REGION 'Form-Min-Max-Normalize' -fold}
  BorderStyle := bsNone;
  {$ifdef Windows}
  SetClassLong(Handle, GCL_STYLE, GetClassLong(Handle, GCL_STYLE) or CS_DROPSHADOW);
  {$endif}
  {$ENDREGION}
end;

{$REGION 'Form-Min-Max-Normalize' -fold}
procedure TForm1.FormMinMaxCloseBtnClicks(Sender: TObject);
begin
  case (Sender as TComponent).Tag of
    0: //minimize
      Application.Minimize; //Application hat eigenes Fenster. // WindowState:=wsMinimized;
    1: begin //maximize & restore
      if WindowState=wsMaximized then begin
        WindowState:=wsNormal;
        LabMaxRestore.Caption:='1';
      end
      else begin
        WindowState:=wsMaximized;
        with Screen.WorkAreaRect do
          SetBounds(Left, Top, Right - Left, Bottom - Top);
        LabMaxRestore.Caption:='2';
      end;
    end;
   2: Close;
  end;
end;

//Man kann unter Windows die folgende 3 Funktionen verzichten und dafür in TForm1.WndProc HTCAPTION verwenden
//aber dann ist das das nicht mehr crossplatform
{$REGION 'Formbewegen ' -fold}
procedure TForm1.FormMoveMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if WindowState=wsMaximized then exit;
  MouseCapture := True;
  md := True;
  x0 := x;
  y0 := y;
end;

procedure TForm1.FormMoveMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if md then begin
    Left := Left - x0 + x;
    Top := Top - y0 + y;
  end;
end;

procedure TForm1.FormMoveMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  md := False;
  MouseCapture := false;
end;
{$ENDREGION}

procedure TForm1.LabelMinMaxCloseMouseEnter(Sender: TObject);
begin
  (Sender as TControl).Font.Color:=clRed;
end;

procedure TForm1.LabelMinMaxCloseMouseLeave(Sender: TObject);
begin
  (Sender as TControl).Font.Color:=clBlack;
end;


// Durch Verwendung von WndProc ist es nicht mehr Crossplatform
// Man kann es wie bei https://github.com/bgrabitmap/bgracontrols/tree/master/test/test_bgra_ribbon_custom
// manuell machen, siehe dort in uMain.pas nach TfrmMain.imgResizeMouseDown und TfrmMain.imgResizeMouseMove
{$IFDEF LCLwin32}
procedure TForm1.WndProc(var Message: TLMessage);
var Pt: TPoint;
begin
  if (not (csDesigning in ComponentState))then
   case Message.Msg of
     WM_NCHITTEST: begin
       Pt:= ScreenToClient(SmallPointToPoint(TSmallPoint(Message.lParam)));
       PanFormTitle.Caption:='x:'+Pt.X.ToString+' y:'+Pt.Y.ToString;
       if (Pt.X<16)and(Pt.Y>(Height-16)) then Message.result :=Windows.HTBOTTOMLEFT
       else if (Pt.X>(Width-16))and(Pt.Y>(Height-16)) then Message.result :=Windows.HTBOTTOMRIGHT
       else if (Pt.X<16)and(Pt.Y<16) then Message.result :=Windows.HTTOPLEFT
       else if (Pt.X>(Width-16))and(Pt.Y<16) then Message.result :=Windows.HTTOPRIGHT
       else if Pt.X<10 then Message.result :=Windows.HTLEFT
       else if Pt.X>(Width-10) then Message.result :=Windows.HTRIGHT;
       if Pt.Y<10 then Message.result :=Windows.HTTOP
       else if Pt.Y>Height-10 then Message.result :=Windows.HTBOTTOM;
     end;
   end;
  inherited;
end;
{$ENDIF}
end.

